define(['exports', '@aurelia-material-components/core', '@material/top-app-bar', 'aurelia-templating', '@material/top-app-bar/dist/mdc.top-app-bar.min.css'], function (exports, _index, _topAppBar, _aureliaTemplating) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.TopAppBarTitle = exports.TopAppBarSection = exports.TopAppBarRow = exports.TopAppBar = undefined;

    function _initDefineProp(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
            enumerable: descriptor.enumerable,
            configurable: descriptor.configurable,
            writable: descriptor.writable,
            value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object['ke' + 'ys'](descriptor).forEach(function (key) {
            desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
            desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
            return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
            desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
            desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
            Object['define' + 'Property'](target, property, desc);
            desc = null;
        }

        return desc;
    }

    function _initializerWarningHelper(descriptor, context) {
        throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
    }

    var _dec, _dec2, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _dec3, _dec4, _class4, _dec5, _dec6, _class5, _desc2, _value2, _class6, _descriptor5, _descriptor6, _dec7, _dec8, _class8;

    var template = '<template>\n    <header class.bind="classSet">\n        <slot></slot>\n    </header>\n</template>';

    var TopAppBar = exports.TopAppBar = (_dec = (0, _aureliaTemplating.customElement)('mdc-top-app-bar'), _dec2 = (0, _aureliaTemplating.inlineView)(template), _dec(_class = _dec2(_class = (0, _aureliaTemplating.containerless)(_class = (_class2 = function (_CustomElement) {
        _inherits(TopAppBar, _CustomElement);

        function TopAppBar() {
            var _temp, _this, _ret;

            _classCallCheck(this, TopAppBar);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return _ret = (_temp = (_this = _possibleConstructorReturn(this, _CustomElement.call.apply(_CustomElement, [this].concat(args))), _this), _initDefineProp(_this, 'fixed', _descriptor, _this), _initDefineProp(_this, 'prominent', _descriptor2, _this), _initDefineProp(_this, 'short', _descriptor3, _this), _initDefineProp(_this, 'shortCollapsed', _descriptor4, _this), _temp), _possibleConstructorReturn(_this, _ret);
        }

        TopAppBar.prototype.atached = function atached() {
            if (this.mdcElement) {
                this.mdcTopAppBar = new _topAppBar.MDCTopAppBar(this.mdcElement);
            }
        };

        _createClass(TopAppBar, [{
            key: 'classSet',
            get: function get() {
                return this.prepareClasses({
                    'mdc-top-app-bar': true,
                    'mdc-top-app-bar--fixed': this.fixed,
                    'mdc-top-app-bar--prominent': this.prominent,
                    'mdc-top-app-bar--short': this.short,
                    'mdc-top-app-bar--short-collapsed': this.shortCollapsed
                });
            }
        }]);

        return TopAppBar;
    }(_index.CustomElement), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'fixed', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return false;
        }
    }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'prominent', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return false;
        }
    }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'short', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return false;
        }
    }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'shortCollapsed', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return false;
        }
    })), _class2)) || _class) || _class) || _class);


    var templateRow = '<template>\n    <div class.bind="classSet">\n        <slot></slot>\n    </div>\n</template>';

    var TopAppBarRow = exports.TopAppBarRow = (_dec3 = (0, _aureliaTemplating.customElement)('mdc-top-app-bar-row'), _dec4 = (0, _aureliaTemplating.inlineView)(templateRow), _dec3(_class4 = _dec4(_class4 = (0, _aureliaTemplating.containerless)(_class4 = function (_CustomElement2) {
        _inherits(TopAppBarRow, _CustomElement2);

        function TopAppBarRow() {
            _classCallCheck(this, TopAppBarRow);

            return _possibleConstructorReturn(this, _CustomElement2.apply(this, arguments));
        }

        _createClass(TopAppBarRow, [{
            key: 'classSet',
            get: function get() {
                return this.prepareClasses({
                    'mdc-top-app-bar__row': true
                });
            }
        }]);

        return TopAppBarRow;
    }(_index.CustomElement)) || _class4) || _class4) || _class4);


    var templateSection = '<template>\n    <span class.bind="classSet">\n        <slot></slot>\n    </span>\n</template>';

    var TopAppBarSection = exports.TopAppBarSection = (_dec5 = (0, _aureliaTemplating.customElement)('mdc-top-app-bar-section'), _dec6 = (0, _aureliaTemplating.inlineView)(templateSection), _dec5(_class5 = _dec6(_class5 = (0, _aureliaTemplating.containerless)(_class5 = (_class6 = function (_CustomElement3) {
        _inherits(TopAppBarSection, _CustomElement3);

        function TopAppBarSection() {
            var _temp2, _this3, _ret2;

            _classCallCheck(this, TopAppBarSection);

            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = arguments[_key2];
            }

            return _ret2 = (_temp2 = (_this3 = _possibleConstructorReturn(this, _CustomElement3.call.apply(_CustomElement3, [this].concat(args))), _this3), _initDefineProp(_this3, 'alignEnd', _descriptor5, _this3), _initDefineProp(_this3, 'alignStart', _descriptor6, _this3), _temp2), _possibleConstructorReturn(_this3, _ret2);
        }

        _createClass(TopAppBarSection, [{
            key: 'classSet',
            get: function get() {
                return this.prepareClasses({
                    'mdc-top-app-bar__section': true,
                    'mdc-top-app-bar__section--align-end': this.alignEnd,
                    'mdc-top-app-bar__section--align-start': this.alignStart
                });
            }
        }]);

        return TopAppBarSection;
    }(_index.CustomElement), (_descriptor5 = _applyDecoratedDescriptor(_class6.prototype, 'alignEnd', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return false;
        }
    }), _descriptor6 = _applyDecoratedDescriptor(_class6.prototype, 'alignStart', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return false;
        }
    })), _class6)) || _class5) || _class5) || _class5);


    var templateTitle = '<template>\n    <span class.bind="classSet">\n        <slot></slot>\n    </span>\n</template>';

    var TopAppBarTitle = exports.TopAppBarTitle = (_dec7 = (0, _aureliaTemplating.customElement)('mdc-top-app-bar-title'), _dec8 = (0, _aureliaTemplating.inlineView)(templateTitle), _dec7(_class8 = _dec8(_class8 = (0, _aureliaTemplating.containerless)(_class8 = function (_CustomElement4) {
        _inherits(TopAppBarTitle, _CustomElement4);

        function TopAppBarTitle() {
            _classCallCheck(this, TopAppBarTitle);

            return _possibleConstructorReturn(this, _CustomElement4.apply(this, arguments));
        }

        _createClass(TopAppBarTitle, [{
            key: 'classSet',
            get: function get() {
                return this.prepareClasses({
                    'mdc-top-app-bar__title': true
                });
            }
        }]);

        return TopAppBarTitle;
    }(_index.CustomElement)) || _class8) || _class8) || _class8);
});