'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TopAppBarTitle = exports.TopAppBarSection = exports.TopAppBarRow = exports.TopAppBar = exports.Config = undefined;
exports.configure = configure;

var _aureliaTemplating = require('aurelia-templating');

var _aureliaPal = require('aurelia-pal');

var _topAppBar = require('./top-app-bar');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Config = exports.Config = function () {
    function Config() {
        _classCallCheck(this, Config);
    }

    Config.prototype.useContainerless = function useContainerless() {
        [_topAppBar.TopAppBar, _topAppBar.TopAppBarRow, _topAppBar.TopAppBarSection, _topAppBar.TopAppBarTitle].forEach(function (definition) {
            return (0, _aureliaTemplating.containerless)(definition);
        });
    };

    Config.prototype.configure = function configure(aurelia) {
        aurelia.globalResources(_aureliaPal.PLATFORM.moduleName('./top-app-bar'));
    };

    return Config;
}();

function configure(aurelia) {
    var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    var config = aurelia.container.get(Config);

    if (typeof callback === 'function') {
        callback(config);
    }

    config.configure(aurelia);
}

exports.TopAppBar = _topAppBar.TopAppBar;
exports.TopAppBarRow = _topAppBar.TopAppBarRow;
exports.TopAppBarSection = _topAppBar.TopAppBarSection;
exports.TopAppBarTitle = _topAppBar.TopAppBarTitle;