function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import { containerless } from 'aurelia-templating';
import { PLATFORM } from 'aurelia-pal';

import { TopAppBar, TopAppBarRow, TopAppBarSection, TopAppBarTitle } from './top-app-bar';

export var Config = function () {
    function Config() {
        _classCallCheck(this, Config);
    }

    Config.prototype.useContainerless = function useContainerless() {
        [TopAppBar, TopAppBarRow, TopAppBarSection, TopAppBarTitle].forEach(function (definition) {
            return containerless(definition);
        });
    };

    Config.prototype.configure = function configure(aurelia) {
        aurelia.globalResources(PLATFORM.moduleName('./top-app-bar'));
    };

    return Config;
}();

export function configure(aurelia) {
    var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    var config = aurelia.container.get(Config);

    if (typeof callback === 'function') {
        callback(config);
    }

    config.configure(aurelia);
}

export { TopAppBar, TopAppBarRow, TopAppBarSection, TopAppBarTitle };