'use strict';

System.register(['aurelia-templating', 'aurelia-pal', './top-app-bar'], function (_export, _context) {
    "use strict";

    var containerless, PLATFORM, TopAppBar, TopAppBarRow, TopAppBarSection, TopAppBarTitle, Config;

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function configure(aurelia) {
        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

        var config = aurelia.container.get(Config);

        if (typeof callback === 'function') {
            callback(config);
        }

        config.configure(aurelia);
    }

    _export('configure', configure);

    return {
        setters: [function (_aureliaTemplating) {
            containerless = _aureliaTemplating.containerless;
        }, function (_aureliaPal) {
            PLATFORM = _aureliaPal.PLATFORM;
        }, function (_topAppBar) {
            TopAppBar = _topAppBar.TopAppBar;
            TopAppBarRow = _topAppBar.TopAppBarRow;
            TopAppBarSection = _topAppBar.TopAppBarSection;
            TopAppBarTitle = _topAppBar.TopAppBarTitle;
        }],
        execute: function () {
            _export('Config', Config = function () {
                function Config() {
                    _classCallCheck(this, Config);
                }

                Config.prototype.useContainerless = function useContainerless() {
                    [TopAppBar, TopAppBarRow, TopAppBarSection, TopAppBarTitle].forEach(function (definition) {
                        return containerless(definition);
                    });
                };

                Config.prototype.configure = function configure(aurelia) {
                    aurelia.globalResources(PLATFORM.moduleName('./top-app-bar'));
                };

                return Config;
            }());

            _export('Config', Config);

            _export('TopAppBar', TopAppBar);

            _export('TopAppBarRow', TopAppBarRow);

            _export('TopAppBarSection', TopAppBarSection);

            _export('TopAppBarTitle', TopAppBarTitle);
        }
    };
});