import { containerless } from 'aurelia-templating';
import { PLATFORM } from 'aurelia-pal';

import { TopAppBar, TopAppBarRow, TopAppBarSection, TopAppBarTitle } from './top-app-bar';

export class Config {
    useContainerless() {
        [
            TopAppBar,
            TopAppBarRow,
            TopAppBarSection,
            TopAppBarTitle
        ].forEach(definition => containerless(definition));
    }

    /**
     * @param {FrameworkConfiguration} aurelia
     */
    configure(aurelia) {
        aurelia.globalResources(PLATFORM.moduleName('./top-app-bar'));
    }
}

/**
 * @param {FrameworkConfiguration} aurelia
 * @param {Function}               [callback=null]
 */
export function configure(aurelia, callback = null) {
    let config = aurelia.container.get(Config);

    if (typeof callback === 'function') {
        callback(config);
    }

    config.configure(aurelia);
}

export {
    TopAppBar,
    TopAppBarRow,
    TopAppBarSection,
    TopAppBarTitle
};
